/*******************************************************************************
* File Name: S3.h  
* Version 1.60
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_S3_H) /* Pins S3_H */
#define CY_PINS_S3_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "S3_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC5 &&\
     CYDEV_CHIP_REVISION_USED == CYDEV_CHIP_REVISION_5A_PRODUCTION &&\
	 S3__PORT == 15 && (S3__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    S3_Write(uint8 value) ;
void    S3_SetDriveMode(uint8 mode) ;
uint8   S3_ReadDataReg(void) ;
uint8   S3_Read(void) ;
uint8   S3_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define S3_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define S3_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define S3_DM_RES_UP          PIN_DM_RES_UP
#define S3_DM_RES_DWN         PIN_DM_RES_DWN
#define S3_DM_OD_LO           PIN_DM_OD_LO
#define S3_DM_OD_HI           PIN_DM_OD_HI
#define S3_DM_STRONG          PIN_DM_STRONG
#define S3_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define S3_MASK               S3__MASK
#define S3_SHIFT              S3__SHIFT
#define S3_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define S3_PS                     (* (reg8 *) S3__PS)
/* Data Register */
#define S3_DR                     (* (reg8 *) S3__DR)
/* Port Number */
#define S3_PRT_NUM                (* (reg8 *) S3__PRT) 
/* Connect to Analog Globals */                                                  
#define S3_AG                     (* (reg8 *) S3__AG)                       
/* Analog MUX bux enable */
#define S3_AMUX                   (* (reg8 *) S3__AMUX) 
/* Bidirectional Enable */                                                        
#define S3_BIE                    (* (reg8 *) S3__BIE)
/* Bit-mask for Aliased Register Access */
#define S3_BIT_MASK               (* (reg8 *) S3__BIT_MASK)
/* Bypass Enable */
#define S3_BYP                    (* (reg8 *) S3__BYP)
/* Port wide control signals */                                                   
#define S3_CTL                    (* (reg8 *) S3__CTL)
/* Drive Modes */
#define S3_DM0                    (* (reg8 *) S3__DM0) 
#define S3_DM1                    (* (reg8 *) S3__DM1)
#define S3_DM2                    (* (reg8 *) S3__DM2) 
/* Input Buffer Disable Override */
#define S3_INP_DIS                (* (reg8 *) S3__INP_DIS)
/* LCD Common or Segment Drive */
#define S3_LCD_COM_SEG            (* (reg8 *) S3__LCD_COM_SEG)
/* Enable Segment LCD */
#define S3_LCD_EN                 (* (reg8 *) S3__LCD_EN)
/* Slew Rate Control */
#define S3_SLW                    (* (reg8 *) S3__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define S3_PRTDSI__CAPS_SEL       (* (reg8 *) S3__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define S3_PRTDSI__DBL_SYNC_IN    (* (reg8 *) S3__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define S3_PRTDSI__OE_SEL0        (* (reg8 *) S3__PRTDSI__OE_SEL0) 
#define S3_PRTDSI__OE_SEL1        (* (reg8 *) S3__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define S3_PRTDSI__OUT_SEL0       (* (reg8 *) S3__PRTDSI__OUT_SEL0) 
#define S3_PRTDSI__OUT_SEL1       (* (reg8 *) S3__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define S3_PRTDSI__SYNC_OUT       (* (reg8 *) S3__PRTDSI__SYNC_OUT) 


#if defined(S3__INTSTAT)  /* Interrupt Registers */

    #define S3_INTSTAT                (* (reg8 *) S3__INTSTAT)
    #define S3_SNAP                   (* (reg8 *) S3__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins S3_H */

#endif
/* [] END OF FILE */
