/*******************************************************************************
* FILENAME: cyfitter_cfg.c
* PSoC Creator 2.0
*
* Description:
* This file is automatically generated by PSoC Creator with device 
* initialization code.
*
* THIS FILE SHOULD NOT BE MODIFIED.
*
********************************************************************************
* Copyright 2011, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include <string.h>
#include <cytypes.h>
#include <cydevice_trm.h>
#include <cyfitter.h>
#include <CyLib.h>
#include <cyfitter_cfg.h>

/* Clock startup error codes                                                   */
#define CYCLOCKSTART_NO_ERROR    0
#define CYCLOCKSTART_XTAL_ERROR  1
#define CYCLOCKSTART_32KHZ_ERROR 2
#define CYCLOCKSTART_PLL_ERROR   3

/*******************************************************************************
* Function Name: CyClockStartupError
********************************************************************************
* Summary:
*  If an error is encountered during clock configuration (crystal startup error,
*  PLL lock error, etc) the system will end up here.  Unless reimplemented by 
*  the customer, an infinite loop will be encountered.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode)
{
    /* To remove the compiler warning if errorCode not used.                */
    errorCode = errorCode;

    /* `#START CyClockStartupError` */

    /* `#END` */

    /* If nothing else, stop here since the clocks have not started         */
    /* correctly.                                                           */
    while(1) {}
}


#undef CYCODE
#undef CYDATA
#undef CYXDATA
#undef CYFAR
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
	#define CYCODE
	#define CYDATA
	#define CYXDATA
	#define CYFAR

	#define CYPACKED __attribute__ ((packed))
	#define CYALIGNED __attribute__ ((aligned))
	
	#if defined(__ARMCC_VERSION)
		#define CY_CFG_MEMORY_BARRIER() __memory_changed()
	#else
		#define CY_CFG_MEMORY_BARRIER() __sync_synchronize()
	#endif
	
    /*******************************************************************************
    * Function Name: cymemzero8
    ********************************************************************************
    * Summary:
    *  This function is provided as a way to initialize a block of memory to zero
    *  one byte at a time.  While this is a 32bit processor, some of the 
    *  configuration registers are only 8bits wide.  This allows us to initialize
    *  just the registers we care about.
    *
    * Parameters:  
    *   addr  - The first address to start writing zero to.
    *   count - The number of bytes to write 0 to.
    *
    * Return:
    *   void
    *
    *******************************************************************************/
    __attribute__ ((unused))
    static void cymemzero8(void *addr, unsigned int count)
    {
	    volatile uint8 *addr8 = (uint8 *)addr;
	    while (count--)
	    {
		    *addr8 = 0;
		    addr8++;
	    }
    }

    /*******************************************************************************
    * Function Name: cymemcpy8
    ********************************************************************************
    * Summary:
    *  This function is provided as a way to copy data from one location to another
    *  one byte at a time.  While this is a 32bit processor, some of the 
    *  configuration registers are only 8bits wide.  This allows us to initialize
    *  just the registers we care about.
    *
    * Parameters:  
    *   dest  - The destination address to copy data to.
    *   src   - The source address to copy data from.
    *   count - The number of bytes to copy from 'src' to 'dest'.
    *
    * Return:
    *   void
    *
    *******************************************************************************/
    __attribute__ ((unused))
    static void cymemcpy8(void *dest, const void *src, unsigned int count)
    {
	    volatile uint8 *dest8 = (uint8 *)dest;
	    const uint8 *src8 = (const uint8 *)src;

	    while (count--)
	    {
		    *dest8 = *src8;
		    dest8++;
		    src8++;
	    }
    }

    #define CYMEMZERO8(a,c) cymemzero8((a),(c))
    #define CYCONFIGCPY8(d,s,c) cymemcpy8((d),(s),(c))
    #define CYCONFIGCPYCODE8(d,s,c) cymemcpy8((d),(s),(c))
	
	#define CYMEMZERO(a,c) memset((a),0,(c))
	#define CYCONFIGCPY(d,s,c) memcpy((d),(s),(c))
	#define CYCONFIGCPYCODE(d,s,c) memcpy((d),(s),(c))
#else
	#error Unsupported toolchain
#endif

/* Defines the layout and meaning of each entry in the cfg_memset_list used for clearing registers */
typedef struct {
	void CYFAR *address;
	uint16 size;
} CYPACKED cfg_memset_t;

/* Defines the layout and meaning of each entry in the cfg_memcpy_list used for initializing registers */
typedef struct {
	void CYFAR *dest;
	const void CYCODE *src;
	uint16 size;
} CYPACKED cfg_memcpy_t;

/* Contains the regions of memory that must be set to 0 during configuration */
#define CFG_MEMSET_COUNT (sizeof(cfg_memset_list)/sizeof(*cfg_memset_list))
static const cfg_memset_t CYCODE cfg_memset_list [] = {
	/* address, size */
	{(void CYFAR *)(CYREG_PRT4_DR), 48},
	{(void CYFAR *)(CYREG_PRT12_DR), 16},
	{(void CYFAR *)(CYREG_PRT15_DR), 16},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_U0_BASE), 4096},
	{(void CYFAR *)(CYDEV_UCFG_B1_P2_U0_BASE), 2048},
	{(void CYFAR *)(CYDEV_UCFG_DSI0_BASE), 2560},
	{(void CYFAR *)(CYDEV_UCFG_DSI12_BASE), 512},
};

#define CY_CFG_BASE_ADDR_COUNT 32
typedef struct
{
	uint8 offset;
	uint8 value;
} CYPACKED cy_cfg_addrvalue_t;

static const uint32 CYCODE cy_cfg_addr_table[] = {
	0x40006404u, /* Base address: 0x40006400 Count: 4 */
	0x40006501u, /* Base address: 0x40006500 Count: 1 */
	0x4001001Du, /* Base address: 0x40010000 Count: 29 */
	0x4001010Fu, /* Base address: 0x40010100 Count: 15 */
	0x4001021Au, /* Base address: 0x40010200 Count: 26 */
	0x40010312u, /* Base address: 0x40010300 Count: 18 */
	0x40010435u, /* Base address: 0x40010400 Count: 53 */
	0x40010521u, /* Base address: 0x40010500 Count: 33 */
	0x40010644u, /* Base address: 0x40010600 Count: 68 */
	0x40010729u, /* Base address: 0x40010700 Count: 41 */
	0x40010902u, /* Base address: 0x40010900 Count: 2 */
	0x40010B03u, /* Base address: 0x40010B00 Count: 3 */
	0x40010D03u, /* Base address: 0x40010D00 Count: 3 */
	0x40010E35u, /* Base address: 0x40010E00 Count: 53 */
	0x40010F17u, /* Base address: 0x40010F00 Count: 23 */
	0x40011417u, /* Base address: 0x40011400 Count: 23 */
	0x4001150Cu, /* Base address: 0x40011500 Count: 12 */
	0x40011630u, /* Base address: 0x40011600 Count: 48 */
	0x4001172Cu, /* Base address: 0x40011700 Count: 44 */
	0x40011902u, /* Base address: 0x40011900 Count: 2 */
	0x4001400Au, /* Base address: 0x40014000 Count: 10 */
	0x40014105u, /* Base address: 0x40014100 Count: 5 */
	0x40014203u, /* Base address: 0x40014200 Count: 3 */
	0x40014301u, /* Base address: 0x40014300 Count: 1 */
	0x40014407u, /* Base address: 0x40014400 Count: 7 */
	0x40014505u, /* Base address: 0x40014500 Count: 5 */
	0x40014604u, /* Base address: 0x40014600 Count: 4 */
	0x40014704u, /* Base address: 0x40014700 Count: 4 */
	0x40014804u, /* Base address: 0x40014800 Count: 4 */
	0x40014C02u, /* Base address: 0x40014C00 Count: 2 */
	0x4001500Cu, /* Base address: 0x40015000 Count: 12 */
	0x40015101u, /* Base address: 0x40015100 Count: 1 */
};

static const cy_cfg_addrvalue_t CYCODE cy_cfg_data_table[] = {
	{0x82u, 0x2Du},
	{0x85u, 0x2Du},
	{0x87u, 0x2Du},
	{0x8Fu, 0x2Du},
	{0x86u, 0x77u},
	{0x8Cu, 0x0Bu},
	{0x98u, 0x08u},
	{0xAEu, 0x05u},
	{0xB0u, 0x08u},
	{0xB2u, 0x01u},
	{0xB4u, 0x02u},
	{0xB6u, 0x04u},
	{0xC0u, 0x10u},
	{0xC1u, 0x04u},
	{0xC9u, 0xFFu},
	{0xCAu, 0xFFu},
	{0xCBu, 0xFFu},
	{0xCDu, 0xA0u},
	{0xCFu, 0x04u},
	{0xD0u, 0x18u},
	{0xD8u, 0x04u},
	{0xDAu, 0x04u},
	{0xDBu, 0x04u},
	{0xDCu, 0x02u},
	{0xDDu, 0x02u},
	{0xE0u, 0x40u},
	{0xE2u, 0xC0u},
	{0xE4u, 0x40u},
	{0xE5u, 0x40u},
	{0xE6u, 0xC0u},
	{0xE8u, 0xC0u},
	{0xEAu, 0xC0u},
	{0xECu, 0xC0u},
	{0xEEu, 0xC0u},
	{0x06u, 0x02u},
	{0x0Eu, 0x04u},
	{0x17u, 0x80u},
	{0x1Cu, 0x50u},
	{0x1Du, 0x80u},
	{0x1Eu, 0x04u},
	{0x45u, 0x80u},
	{0x46u, 0x80u},
	{0x77u, 0x80u},
	{0x80u, 0x10u},
	{0x85u, 0x20u},
	{0xC0u, 0x80u},
	{0xC2u, 0x40u},
	{0xC4u, 0x80u},
	{0xD0u, 0x90u},
	{0x40u, 0x10u},
	{0x41u, 0x04u},
	{0x45u, 0xD0u},
	{0x46u, 0x02u},
	{0x47u, 0x10u},
	{0x48u, 0x26u},
	{0x49u, 0xFFu},
	{0x4Au, 0xFFu},
	{0x4Bu, 0xFFu},
	{0x4Du, 0xAFu},
	{0x4Eu, 0x0Fu},
	{0x4Fu, 0x04u},
	{0x50u, 0x18u},
	{0x54u, 0x25u},
	{0x5Au, 0x04u},
	{0x5Bu, 0x04u},
	{0x5Du, 0x22u},
	{0x60u, 0x40u},
	{0x62u, 0xC0u},
	{0x64u, 0x40u},
	{0x65u, 0x40u},
	{0x66u, 0xC0u},
	{0x68u, 0xC0u},
	{0x6Au, 0xC0u},
	{0x6Cu, 0xC0u},
	{0x6Eu, 0xC0u},
	{0x45u, 0x80u},
	{0x46u, 0x80u},
	{0x4Fu, 0x01u},
	{0x56u, 0x82u},
	{0x5Cu, 0x40u},
	{0x5Eu, 0x04u},
	{0x5Fu, 0x01u},
	{0x64u, 0x04u},
	{0x86u, 0x84u},
	{0x90u, 0x40u},
	{0x9Eu, 0x82u},
	{0xA1u, 0x80u},
	{0xA3u, 0x04u},
	{0xA5u, 0x20u},
	{0xABu, 0x04u},
	{0xD0u, 0x90u},
	{0xD6u, 0xD0u},
	{0xD8u, 0x20u},
	{0x40u, 0x10u},
	{0x41u, 0x03u},
	{0x49u, 0xFFu},
	{0x4Au, 0xFFu},
	{0x4Bu, 0xFFu},
	{0x4Du, 0xA0u},
	{0x4Fu, 0x04u},
	{0x50u, 0x18u},
	{0x5Au, 0x04u},
	{0x5Du, 0x02u},
	{0x60u, 0x40u},
	{0x62u, 0xC0u},
	{0x64u, 0x40u},
	{0x65u, 0x40u},
	{0x66u, 0xC0u},
	{0x68u, 0xC0u},
	{0x6Au, 0xC0u},
	{0x6Cu, 0xC0u},
	{0x6Eu, 0xC0u},
	{0x83u, 0x05u},
	{0x95u, 0x08u},
	{0xADu, 0x0Bu},
	{0xB1u, 0x08u},
	{0xB3u, 0x02u},
	{0xB5u, 0x01u},
	{0xB7u, 0x04u},
	{0xC0u, 0x40u},
	{0xC1u, 0x02u},
	{0xC5u, 0xD0u},
	{0xC7u, 0x12u},
	{0xC8u, 0x32u},
	{0xC9u, 0xFFu},
	{0xCAu, 0xFFu},
	{0xCBu, 0xFFu},
	{0xCDu, 0xAFu},
	{0xCEu, 0x0Fu},
	{0xCFu, 0x04u},
	{0xD0u, 0x18u},
	{0xD4u, 0x25u},
	{0xD9u, 0x04u},
	{0xDAu, 0x04u},
	{0xDBu, 0x04u},
	{0xDCu, 0x20u},
	{0xDDu, 0x22u},
	{0xE0u, 0x40u},
	{0xE2u, 0xC0u},
	{0xE4u, 0x40u},
	{0xE5u, 0x40u},
	{0xE6u, 0xC0u},
	{0xE8u, 0xC0u},
	{0xEAu, 0xC0u},
	{0xECu, 0xC0u},
	{0xEEu, 0xC0u},
	{0x24u, 0x41u},
	{0x25u, 0x20u},
	{0x26u, 0x08u},
	{0x27u, 0x02u},
	{0x2Fu, 0x02u},
	{0x36u, 0x08u},
	{0x3Cu, 0x02u},
	{0x40u, 0x01u},
	{0x43u, 0x08u},
	{0x44u, 0x08u},
	{0x46u, 0x04u},
	{0x47u, 0x02u},
	{0x4Fu, 0x01u},
	{0x56u, 0x04u},
	{0x57u, 0x0Au},
	{0x5Cu, 0x48u},
	{0x5Fu, 0x01u},
	{0x64u, 0x04u},
	{0x74u, 0x01u},
	{0x93u, 0x40u},
	{0x98u, 0x04u},
	{0xA3u, 0x04u},
	{0xA5u, 0x20u},
	{0xACu, 0x04u},
	{0xAFu, 0x40u},
	{0xCAu, 0x10u},
	{0xCCu, 0x40u},
	{0xCEu, 0x80u},
	{0xD0u, 0xAAu},
	{0xD6u, 0xD0u},
	{0xD8u, 0x20u},
	{0xEAu, 0x08u},
	{0xECu, 0x10u},
	{0x03u, 0x02u},
	{0x07u, 0x08u},
	{0x0Fu, 0x03u},
	{0x11u, 0x02u},
	{0x1Du, 0x08u},
	{0x25u, 0x04u},
	{0x31u, 0x01u},
	{0x33u, 0x02u},
	{0x35u, 0x04u},
	{0x37u, 0x08u},
	{0x3Fu, 0x54u},
	{0x40u, 0x60u},
	{0x41u, 0x04u},
	{0x49u, 0xFFu},
	{0x4Au, 0xFFu},
	{0x4Bu, 0xFFu},
	{0x4Du, 0xA0u},
	{0x4Fu, 0x04u},
	{0x50u, 0x18u},
	{0x59u, 0x04u},
	{0x5Au, 0x04u},
	{0x5Bu, 0x04u},
	{0x5Cu, 0x90u},
	{0x5Du, 0x02u},
	{0x60u, 0x40u},
	{0x62u, 0xC0u},
	{0x64u, 0x40u},
	{0x65u, 0x40u},
	{0x66u, 0xC0u},
	{0x68u, 0xC0u},
	{0x6Au, 0xC0u},
	{0x6Cu, 0xC0u},
	{0x6Eu, 0xC0u},
	{0x88u, 0x08u},
	{0x92u, 0x05u},
	{0xA8u, 0x0Bu},
	{0xB0u, 0x01u},
	{0xB2u, 0x02u},
	{0xB4u, 0x04u},
	{0xB6u, 0x08u},
	{0xC0u, 0x60u},
	{0xC1u, 0x01u},
	{0xC5u, 0xD0u},
	{0xC6u, 0x02u},
	{0xC7u, 0x01u},
	{0xC8u, 0x16u},
	{0xC9u, 0xFFu},
	{0xCAu, 0xFFu},
	{0xCBu, 0xFFu},
	{0xCDu, 0xAFu},
	{0xCEu, 0x0Fu},
	{0xCFu, 0x04u},
	{0xD0u, 0x18u},
	{0xD4u, 0x25u},
	{0xD8u, 0x04u},
	{0xDAu, 0x04u},
	{0xDBu, 0x04u},
	{0xDCu, 0x02u},
	{0xDDu, 0x22u},
	{0xE0u, 0x40u},
	{0xE2u, 0xC0u},
	{0xE4u, 0x40u},
	{0xE5u, 0x40u},
	{0xE6u, 0xC0u},
	{0xE8u, 0xC0u},
	{0xEAu, 0xC0u},
	{0xECu, 0xC0u},
	{0xEEu, 0xC0u},
	{0x00u, 0x10u},
	{0x09u, 0x02u},
	{0x10u, 0x08u},
	{0x16u, 0x80u},
	{0x17u, 0x01u},
	{0x18u, 0x10u},
	{0x19u, 0xA0u},
	{0x1Bu, 0x02u},
	{0x24u, 0x04u},
	{0x26u, 0x0Au},
	{0x27u, 0x01u},
	{0x2Eu, 0x04u},
	{0x36u, 0x82u},
	{0x3Cu, 0x02u},
	{0x3Fu, 0x48u},
	{0x43u, 0x80u},
	{0x46u, 0x40u},
	{0x49u, 0x21u},
	{0x4Du, 0x20u},
	{0x50u, 0x08u},
	{0x52u, 0x40u},
	{0x53u, 0x80u},
	{0x59u, 0x89u},
	{0x60u, 0x04u},
	{0x71u, 0x02u},
	{0x74u, 0x01u},
	{0x81u, 0x08u},
	{0x83u, 0x80u},
	{0x8Fu, 0x02u},
	{0x93u, 0x40u},
	{0xA3u, 0x04u},
	{0xC0u, 0x02u},
	{0xC2u, 0x08u},
	{0xC4u, 0x02u},
	{0xCAu, 0x40u},
	{0xCCu, 0x90u},
	{0xCEu, 0xD0u},
	{0xD0u, 0x88u},
	{0xD2u, 0x24u},
	{0xD6u, 0x0Bu},
	{0xD8u, 0x04u},
	{0x9Eu, 0x20u},
	{0xE4u, 0x40u},
	{0x9Eu, 0x20u},
	{0xAEu, 0x20u},
	{0xECu, 0x10u},
	{0x9Eu, 0x20u},
	{0xB2u, 0x04u},
	{0xB7u, 0x48u},
	{0x40u, 0x50u},
	{0x41u, 0x01u},
	{0x49u, 0xFFu},
	{0x4Au, 0xFFu},
	{0x4Bu, 0xFFu},
	{0x4Du, 0xA0u},
	{0x4Fu, 0x04u},
	{0x50u, 0x18u},
	{0x5Au, 0x04u},
	{0x5Du, 0x02u},
	{0x60u, 0x40u},
	{0x62u, 0xC0u},
	{0x64u, 0x40u},
	{0x65u, 0x40u},
	{0x66u, 0xC0u},
	{0x68u, 0xC0u},
	{0x6Au, 0xC0u},
	{0x6Cu, 0xC0u},
	{0x6Eu, 0xC0u},
	{0x88u, 0x08u},
	{0x94u, 0x0Bu},
	{0xAEu, 0x05u},
	{0xB0u, 0x08u},
	{0xB2u, 0x02u},
	{0xB4u, 0x01u},
	{0xB6u, 0x04u},
	{0xC0u, 0x10u},
	{0xC1u, 0x05u},
	{0xC5u, 0xD0u},
	{0xC6u, 0x12u},
	{0xC8u, 0x0Eu},
	{0xC9u, 0xFFu},
	{0xCAu, 0xFFu},
	{0xCBu, 0xFFu},
	{0xCDu, 0xAFu},
	{0xCEu, 0x0Fu},
	{0xCFu, 0x04u},
	{0xD0u, 0x18u},
	{0xD4u, 0x25u},
	{0xD8u, 0x04u},
	{0xDAu, 0x04u},
	{0xDBu, 0x04u},
	{0xDCu, 0x02u},
	{0xDDu, 0x22u},
	{0xE0u, 0x40u},
	{0xE2u, 0xC0u},
	{0xE4u, 0x40u},
	{0xE5u, 0x40u},
	{0xE6u, 0xC0u},
	{0xE8u, 0xC0u},
	{0xEAu, 0xC0u},
	{0xECu, 0xC0u},
	{0xEEu, 0xC0u},
	{0x04u, 0x10u},
	{0x0Fu, 0x20u},
	{0x17u, 0x80u},
	{0x1Cu, 0x50u},
	{0x1Du, 0x80u},
	{0x1Eu, 0x04u},
	{0x1Fu, 0x40u},
	{0x43u, 0x80u},
	{0x45u, 0x80u},
	{0x4Bu, 0x80u},
	{0x4Fu, 0x81u},
	{0x57u, 0xD0u},
	{0x5Cu, 0x40u},
	{0x5Fu, 0x09u},
	{0x66u, 0x20u},
	{0x77u, 0x80u},
	{0xC0u, 0x40u},
	{0xC2u, 0x20u},
	{0xC4u, 0x80u},
	{0xD0u, 0x18u},
	{0xD2u, 0x18u},
	{0xD6u, 0xD0u},
	{0xD8u, 0x20u},
	{0xC0u, 0x65u},
	{0xC1u, 0x02u},
	{0xC2u, 0x04u},
	{0xC9u, 0xFFu},
	{0xCAu, 0xFFu},
	{0xCBu, 0xFFu},
	{0xCDu, 0xA0u},
	{0xCFu, 0x01u},
	{0xD0u, 0x18u},
	{0xDAu, 0x04u},
	{0xDDu, 0x09u},
	{0xE0u, 0x40u},
	{0xE2u, 0x80u},
	{0xE4u, 0x40u},
	{0xE5u, 0x40u},
	{0xE6u, 0x80u},
	{0xE8u, 0x40u},
	{0xEAu, 0x50u},
	{0xEBu, 0xA8u},
	{0xECu, 0x40u},
	{0xEDu, 0x20u},
	{0xEEu, 0x50u},
	{0xEFu, 0xA8u},
	{0x30u, 0x04u},
	{0x31u, 0x08u},
	{0x44u, 0x04u},
	{0x47u, 0x01u},
	{0x4Cu, 0x02u},
	{0x4Eu, 0x08u},
	{0x9Bu, 0x01u},
	{0xA0u, 0x02u},
	{0xA1u, 0x08u},
	{0xA2u, 0x08u},
	{0xD0u, 0xA0u},
	{0xD2u, 0x30u},
	{0x03u, 0x08u},
	{0x07u, 0x04u},
	{0x19u, 0x02u},
	{0x1Eu, 0x01u},
	{0x2Cu, 0x01u},
	{0x2Fu, 0x03u},
	{0x30u, 0x01u},
	{0x31u, 0x08u},
	{0x33u, 0x01u},
	{0x35u, 0x02u},
	{0x37u, 0x04u},
	{0x38u, 0x28u},
	{0x3Eu, 0x05u},
	{0x3Fu, 0x10u},
	{0x40u, 0x65u},
	{0x41u, 0x03u},
	{0x42u, 0x04u},
	{0x45u, 0x5Cu},
	{0x46u, 0x20u},
	{0x47u, 0x0Eu},
	{0x48u, 0x3Bu},
	{0x49u, 0xFFu},
	{0x4Au, 0xFFu},
	{0x4Bu, 0xFFu},
	{0x4Du, 0xAFu},
	{0x4Eu, 0x07u},
	{0x4Fu, 0x01u},
	{0x50u, 0x18u},
	{0x54u, 0x17u},
	{0x56u, 0x04u},
	{0x58u, 0x04u},
	{0x59u, 0x04u},
	{0x5Au, 0x04u},
	{0x5Bu, 0x04u},
	{0x5Cu, 0x92u},
	{0x5Du, 0x99u},
	{0x60u, 0x40u},
	{0x62u, 0x80u},
	{0x64u, 0x40u},
	{0x65u, 0x40u},
	{0x66u, 0x80u},
	{0x68u, 0x40u},
	{0x6Au, 0x50u},
	{0x6Bu, 0xA8u},
	{0x6Cu, 0x40u},
	{0x6Du, 0x20u},
	{0x6Eu, 0x50u},
	{0x6Fu, 0xA8u},
	{0x0Fu, 0x02u},
	{0x17u, 0x40u},
	{0x1Du, 0x08u},
	{0x1Eu, 0x84u},
	{0x24u, 0x04u},
	{0x26u, 0x80u},
	{0x27u, 0x60u},
	{0x2Cu, 0x02u},
	{0x37u, 0x20u},
	{0x3Fu, 0x0Au},
	{0x45u, 0x08u},
	{0x47u, 0x01u},
	{0x4Cu, 0x02u},
	{0x4Eu, 0x08u},
	{0x4Fu, 0x06u},
	{0x54u, 0x02u},
	{0x56u, 0x08u},
	{0x57u, 0x10u},
	{0x5Cu, 0x04u},
	{0x5Eu, 0x80u},
	{0x5Fu, 0x10u},
	{0x63u, 0x30u},
	{0x66u, 0x88u},
	{0x67u, 0x44u},
	{0x85u, 0x08u},
	{0x87u, 0x40u},
	{0x96u, 0x04u},
	{0x9Au, 0x80u},
	{0x9Bu, 0x01u},
	{0xA2u, 0x08u},
	{0xA3u, 0x04u},
	{0xA6u, 0x80u},
	{0xA8u, 0x04u},
	{0xC2u, 0x80u},
	{0xC4u, 0x80u},
	{0xCAu, 0x10u},
	{0xCCu, 0x20u},
	{0xCEu, 0xC0u},
	{0xD0u, 0xC0u},
	{0xD2u, 0x30u},
	{0xD6u, 0x70u},
	{0xD8u, 0xF0u},
	{0xE0u, 0x02u},
	{0xE8u, 0x04u},
	{0xAAu, 0x20u},
	{0xE0u, 0x02u},
	{0x03u, 0x20u},
	{0x5Eu, 0x01u},
	{0x65u, 0x20u},
	{0x81u, 0x20u},
	{0x86u, 0x01u},
	{0xC0u, 0x10u},
	{0xD6u, 0x80u},
	{0xD8u, 0x80u},
	{0xE2u, 0x10u},
	{0xE6u, 0x80u},
	{0x10u, 0x20u},
	{0x17u, 0x02u},
	{0xABu, 0x20u},
	{0xC4u, 0x30u},
	{0xECu, 0x20u},
	{0xAFu, 0x02u},
	{0xB4u, 0x20u},
	{0xECu, 0x40u},
	{0xC2u, 0x10u},
	{0x45u, 0x02u},
	{0x50u, 0x80u},
	{0x54u, 0x20u},
	{0x77u, 0x80u},
	{0xD0u, 0x01u},
	{0xD4u, 0x06u},
	{0xDEu, 0x04u},
	{0x9Fu, 0x80u},
	{0xA4u, 0x80u},
	{0xA5u, 0x02u},
	{0xB0u, 0x20u},
	{0xECu, 0x04u},
	{0x9Fu, 0x80u},
	{0xA4u, 0x80u},
	{0xB5u, 0x02u},
	{0xECu, 0x08u},
	{0x8Cu, 0x80u},
	{0x9Fu, 0x80u},
	{0xA4u, 0x80u},
	{0xE4u, 0x02u},
	{0x3Bu, 0x20u},
	{0x87u, 0x10u},
	{0xCEu, 0x10u},
	{0xE6u, 0x40u},
	{0x87u, 0x80u},
	{0x9Fu, 0x80u},
	{0x00u, 0x04u},
	{0x01u, 0x01u},
	{0x02u, 0x10u},
	{0x08u, 0x04u},
	{0x0Au, 0x04u},
	{0x0Bu, 0x01u},
	{0x0Eu, 0x04u},
	{0x10u, 0x04u},
	{0x11u, 0x01u},
	{0x12u, 0x10u},
	{0x1Au, 0x04u},
	{0x1Bu, 0x01u},
	{0x06u, 0x0Cu},
};


/* IOPINS0_0 Address: CYREG_PRT0_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_0_VAL[] = {
	0x00, 0x03, 0x03, 0x00, 0x03, 0x00, 0x18, 0x00};

/* IOPINS0_1 Address: CYREG_PRT1_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_1_VAL[] = {
	0x00, 0xF0, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPINS0_2 Address: CYREG_PRT2_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_2_VAL[] = {
	0x00, 0x7F, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPINS0_3 Address: CYREG_PRT3_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_3_VAL[] = {
	0x01, 0x56, 0x56, 0x00, 0x50, 0x00, 0x00, 0x00};

/* IOPORT_0 Address: CYDEV_PRTDSI_PRT0_BASE Size (bytes): 7 */
static const uint8 CYCODE BS_IOPORT_0_VAL[] = {
	0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPORT_3 Address: CYDEV_PRTDSI_PRT3_BASE Size (bytes): 7 */
static const uint8 CYCODE BS_IOPORT_3_VAL[] = {
	0x50, 0x40, 0x00, 0x00, 0x01, 0x00, 0x00};

/* CYDEV_CLKDIST_ACFG0_CFG0 Address: CYREG_CLKDIST_ACFG0_CFG0 Size (bytes): 4 */
static const uint8 CYCODE BS_CYDEV_CLKDIST_ACFG0_CFG0_VAL[] = {
	0x0C, 0x00, 0x18, 0x01};


/*******************************************************************************
* Function Name: cfg_write_bytes32
********************************************************************************
* Summary:
*  This function is used for setting up the chip configuration areas that 
*  contain relativly sparse data.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
/* For 32-bit little-endian architectures */
static void cfg_write_bytes32(void)
{
	unsigned int i, j = 0;
	for (i = 0; i < CY_CFG_BASE_ADDR_COUNT; i++)
	{
		uint32 baseAddr = cy_cfg_addr_table[i];
		uint8 count = baseAddr & 0xFFu;
		baseAddr &= 0xFFFFFF00u;
		while (count--)
		{
			CY_SET_XTND_REG8((void CYFAR *)(baseAddr + cy_cfg_data_table[j].offset), cy_cfg_data_table[j].value);
			j++;
		}
	}
}

/*******************************************************************************
* Function Name: ClockSetup
********************************************************************************
*
* Summary:
*  Performs the initialization of all of the clocks in the device based on the
*  settings in the Clock tab of the DWR.  This includes enabling the requested
*  clocks and setting the necessary dividers to produce the desired frequency. 
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
static void ClockSetup(void)
{
	reg32  timeout;
	reg32* timeout_p = &timeout;
	reg8   pllLock;


	/* Configure Digital Clocks based on settings from Clock DWR */
	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG0_CFG0), 0x180002);
	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG1_CFG0), 0x190000);
	CY_SET_XTND_REG24((void CYFAR *)(CYREG_CLKDIST_DCFG2_CFG0), 0x190095);

	/* Configure Analog Clocks based on settings from Clock DWR */
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_CLKDIST_ACFG0_CFG0), (void CYCODE *)(BS_CYDEV_CLKDIST_ACFG0_CFG0_VAL), 4);

	/* Configure ILO based on settings from Clock DWR */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_SLOWCLK_ILO_CR0), 0x02);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_CR), 0x08);

	/* Configure IMO based on settings from Clock DWR */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_FASTCLK_IMO_CR), 0x03);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_IMO_TR1), (CY_GET_XTND_REG8(CYREG_FLSHID_CUST_TABLES_IMO_3MHZ)));

	/* Configure PLL based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_P), 0x0008);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_CFG0), 0x1051);
	/* Wait up to 250us for the PLL to lock */
	pllLock = 0;
	for (timeout = 250 / 10; *timeout_p && (pllLock != 0x03u); timeout--) { 
		pllLock = 0x03u & ((pllLock << 1) | ((CY_GET_XTND_REG8(CYREG_FASTCLK_PLL_SR) & 0x01u) >> 0));
		CyDelayCycles(10 * 12); /* Delay 10us based on 12MHz clock */
	}

	/* Configure Bus/Master Clock based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x0103);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x07);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG2), 0x48);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_LD), 0x02);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_DLY1), 0x04);

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PM_ACT_CFG2), ((CY_GET_XTND_REG8(CYREG_PM_ACT_CFG2) | 0x07)));
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PM_ACT_CFG1), ((CY_GET_XTND_REG8(CYREG_PM_ACT_CFG1) | 0x01)));
}


/* Analog API Functions */

/*******************************************************************************
* Function Name: AnalogSetDefault
********************************************************************************
*
* Summary:
*  Sets up the analog portions of the chip to default values based on chip
*  configuration options from the project.
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
void AnalogSetDefault(void)
{
	CY_SET_XTND_REG16(CYREG_PM_ACT_CFG10, 0x0310);
	CY_SET_XTND_REG8(CYREG_DAC0_CR0, 0x1E);
	CY_SET_XTND_REG8(CYREG_DAC1_CR0, 0x1E);
	CY_SET_XTND_REG8(CYREG_DAC2_CR0, 0x1E);
	CY_SET_XTND_REG8(CYREG_DAC3_CR0, 0x1E);
	CY_SET_XTND_REG8(CYREG_SAR0_CSR0, 0xC0);
	CY_SET_XTND_REG8(CYREG_SAR0_CSR3, 0x0C);
	CY_SET_XTND_REG8(CYREG_SAR1_CSR0, 0xC0);
	CY_SET_XTND_REG8(CYREG_SAR1_CSR3, 0x0C);
	CY_SET_XTND_REG8(CYREG_PUMP_CR0, 0x44);
}

#define CY_AMUX_UNUSED CYREG_BOOST_SR
/* Table used to specify registers used to implement AMux */
uint8 CYXDATA * const CYCODE AMux__addrTable[] = {
	(uint8 CYXDATA *)CYREG_PRT0_AG, (uint8 CYXDATA *)CYREG_DSM0_SW0, 
	(uint8 CYXDATA *)CYREG_PRT0_AG, (uint8 CYXDATA *)CYREG_DSM0_SW0, 
};

/* Table used to define bit masks used to enable inputs for AMux */
const uint8 CYCODE AMux__maskTable[] = {
	0x10, 0x10, 
	0x08, 0x80, 
};

/*******************************************************************************
* Function Name: AMux_Set
********************************************************************************
* Summary:
*  This function is used to set a particular channel as active on the AMux.
*
* Parameters:  
*   channel - The mux channel input to set as active
*
* Return:
*   void
*
*******************************************************************************/
void AMux_Set(uint8 channel)
{
	if (channel >= 2)
		return;
	channel += channel;
	*AMux__addrTable[channel] |= AMux__maskTable[channel];
	channel++;
	*AMux__addrTable[channel] |= AMux__maskTable[channel];
}

/*******************************************************************************
* Function Name: AMux_Unset
********************************************************************************
* Summary:
*  This function is used to clear a particular channel from being active on the
*  AMux.
*
* Parameters:  
*   channel - The mux channel input to mark inactive
*
* Return:
*   void
*
*******************************************************************************/
void AMux_Unset(uint8 channel)
{
	if (channel >= 2)
		return;
	channel += channel;
	*AMux__addrTable[channel] &= ~AMux__maskTable[channel];
	channel++;
	*AMux__addrTable[channel] &= ~AMux__maskTable[channel];
}

/* Table used to specify registers used to implement ADC_DelSig_1_AMux */
uint8 CYXDATA * const CYCODE ADC_DelSig_1_AMux__addrTable[] = {
	(uint8 CYXDATA *)CYREG_DSM0_SW3, 
	(uint8 CYXDATA *)CYREG_DSM0_SW3, 
};

/* Table used to define bit masks used to enable inputs for ADC_DelSig_1_AMux */
const uint8 CYCODE ADC_DelSig_1_AMux__maskTable[] = {
	0x40, 
	0x40, 
};

/*******************************************************************************
* Function Name: ADC_DelSig_1_AMux_Set
********************************************************************************
* Summary:
*  This function is used to set a particular channel as active on the AMux.
*
* Parameters:  
*   channel - The mux channel input to set as active
*
* Return:
*   void
*
*******************************************************************************/
void ADC_DelSig_1_AMux_Set(uint8 channel)
{
	if (channel >= 2)
		return;
	*ADC_DelSig_1_AMux__addrTable[channel] |= ADC_DelSig_1_AMux__maskTable[channel];
}

/*******************************************************************************
* Function Name: ADC_DelSig_1_AMux_Unset
********************************************************************************
* Summary:
*  This function is used to clear a particular channel from being active on the
*  AMux.
*
* Parameters:  
*   channel - The mux channel input to mark inactive
*
* Return:
*   void
*
*******************************************************************************/
void ADC_DelSig_1_AMux_Unset(uint8 channel)
{
	if (channel >= 2)
		return;
	*ADC_DelSig_1_AMux__addrTable[channel] &= ~ADC_DelSig_1_AMux__maskTable[channel];
}



/*******************************************************************************
* Function Name: cyfitter_cfg
********************************************************************************
* Summary:
*  This function is called by the start-up code for the selected device. It
*  performs all of the necessary device configuration based on the design
*  settings.  This includes settings from the Design Wide Resources (DWR) such
*  as Clocks and Pins as well as any component configuration that is necessary.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
void cyfitter_cfg(void)
{
#ifdef CYGlobalIntDisable
	/* Disable interrupts by default. Let user enable if/when they want. */
	CYGlobalIntDisable;
#endif

	/* Setup Flash Cycles based on 12MHz clock startup frequency. */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x40 : 0x41));

	/* Disable DMA channels so they can be configured for chip initialization */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH0_BASIC_CFG), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH1_BASIC_CFG), 0x00);

	/* Enable analog pulldown switches */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_ANAIF_CFG_MISC_CR0), 0x01);

	/* Enable/Disable Debug functionality based on settings from System DWR */
	CY_SET_XTND_REG8(CYREG_MLOGIC_DBG_DBE, (CY_GET_XTND_REG8(CYREG_MLOGIC_DBG_DBE) | 0x01));

	{
		uint8 CYDATA i;

		/* Zero out critical memory blocks before beginning configuration */
		for (i = 0; i < CFG_MEMSET_COUNT; i++)
		{
			const cfg_memset_t CYCODE * CYDATA ms = &cfg_memset_list[i];
			CYMEMZERO(ms->address, ms->size);
		}

		cfg_write_bytes32();

		/* Perform normal device configuration. Order is not critical for these items. */
		CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT0_BASE), (void CYCODE *)(BS_IOPORT_0_VAL), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT1_BASE), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT2_BASE), 7);
		CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT3_BASE), (void CYCODE *)(BS_IOPORT_3_VAL), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT4_BASE), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT5_BASE), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT6_BASE), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT12_BASE), 6);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT15_BASE), 7);

		/* Enable digital routing */
		CY_SET_XTND_REG8(CYREG_BCTL0_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL0_BANK_CTL) | 0x02u);
		CY_SET_XTND_REG8(CYREG_BCTL1_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL1_BANK_CTL) | 0x02u);

		/* Enable UDB array */
		CY_SET_XTND_REG8(CYREG_PM_ACT_CFG0, CY_GET_XTND_REG8(CYREG_PM_ACT_CFG0) | 0x40u);
		CY_SET_XTND_REG8(CYREG_PM_AVAIL_CR2, CY_GET_XTND_REG8(CYREG_PM_AVAIL_CR2) | 0x10u);
	}

	/* Perform second pass device configuration. These items must be configured in specific order after the regular configuration is done. */
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT0_DM0), (void CYCODE *)(BS_IOPINS0_0_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT1_DM0), (void CYCODE *)(BS_IOPINS0_1_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT2_DM0), (void CYCODE *)(BS_IOPINS0_2_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT3_DM0), (void CYCODE *)(BS_IOPINS0_3_VAL), 8);


	/* Set Flash Cycles based on max possible frequency in case a glitch occurs during ClockSetup(). */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x00 : 0x01));
	/* Setup clocks based on selections from Clock DWR */
	ClockSetup();
	/* Set Flash Cycles based on newly configured 24.00MHz Bus Clock. */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x80 : 0x81));

	/* Perform basic analog initialization to defaults */
	AnalogSetDefault();

	/* Configure alternate active mode */
	CYCONFIGCPY((void CYFAR *)CYDEV_PM_STBY_BASE, (void CYFAR *)CYDEV_PM_ACT_BASE, 12);
	CY_SET_XTND_REG8(CYREG_PM_STBY_CFG0, CY_GET_XTND_REG8(CYREG_PM_STBY_CFG0) & ~0x02u);	/* Disable CPU */
}
